## API Report File for "@fluentui/react-table"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

/// <reference types="react" />

import { ARIAButtonSlotProps } from '@fluentui/react-aria';
import type { AvatarSizes } from '@fluentui/react-avatar';
import type { Checkbox } from '@fluentui/react-checkbox';
import type { CheckboxProps } from '@fluentui/react-checkbox';
import type { ComponentProps } from '@fluentui/react-utilities';
import type { ComponentState } from '@fluentui/react-utilities';
import type { ForwardRefComponent } from '@fluentui/react-utilities';
import type { Radio } from '@fluentui/react-radio';
import * as React_2 from 'react';
import { ReactNode } from 'react';
import type { Slot } from '@fluentui/react-utilities';
import type { SlotClassNames } from '@fluentui/react-utilities';

// @public (undocumented)
export type CellRenderFunction = (column: ColumnDefinition<any>) => React_2.ReactNode;

// @public (undocumented)
export interface ColumnDefinition<TItem> {
    // (undocumented)
    columnId: ColumnId;
    // (undocumented)
    compare: (a: TItem, b: TItem) => number;
    // (undocumented)
    renderCell: (item: TItem) => React_2.ReactNode;
    // (undocumented)
    renderHeaderCell: () => React_2.ReactNode;
}

// @public (undocumented)
export type ColumnId = string | number;

// @public
export function createColumn<TItem>(options: CreateColumnOptions<TItem>): {
    columnId: ColumnId;
    renderCell: (item: TItem) => ReactNode;
    renderHeaderCell: () => ReactNode;
    compare: (a: TItem, b: TItem) => number;
};

// @public (undocumented)
export interface CreateColumnOptions<TItem> extends Partial<ColumnDefinition<TItem>> {
    // (undocumented)
    columnId: ColumnId;
}

// @public
export const DataGrid: ForwardRefComponent<DataGridProps>;

// @public
export const DataGridBody: ForwardRefComponent<DataGridBodyProps>;

// @public (undocumented)
export const dataGridBodyClassNames: SlotClassNames<DataGridBodySlots>;

// @public
export type DataGridBodyProps = Omit<TableBodyProps, 'children'> & {
    children: RowRenderFunction;
};

// @public (undocumented)
export type DataGridBodySlots = TableBodySlots;

// @public
export type DataGridBodyState = TableBodyState;

// @public
export const DataGridCell: ForwardRefComponent<DataGridCellProps>;

// @public (undocumented)
export const dataGridCellClassNames: SlotClassNames<DataGridCellSlots>;

// @public
export type DataGridCellProps = TableCellProps;

// @public (undocumented)
export type DataGridCellSlots = TableCellSlots;

// @public
export type DataGridCellState = TableCellState;

// @public (undocumented)
export const dataGridClassNames: SlotClassNames<DataGridSlots>;

// @public (undocumented)
export type DataGridContextValue = HeadlessTableState<any>;

// @public (undocumented)
export type DataGridContextValues = TableContextValues & {
    dataGrid: DataGridContextValue;
};

// @public
export const DataGridHeader: ForwardRefComponent<DataGridHeaderProps>;

// @public
export const DataGridHeaderCell: ForwardRefComponent<DataGridHeaderCellProps>;

// @public (undocumented)
export const dataGridHeaderCellClassNames: SlotClassNames<DataGridHeaderCellSlots>;

// @public
export type DataGridHeaderCellProps = TableHeaderCellProps;

// @public (undocumented)
export type DataGridHeaderCellSlots = TableHeaderCellSlots;

// @public
export type DataGridHeaderCellState = TableHeaderCellState;

// @public (undocumented)
export const dataGridHeaderClassNames: SlotClassNames<DataGridHeaderSlots>;

// @public
export type DataGridHeaderProps = TableHeaderProps;

// @public (undocumented)
export type DataGridHeaderSlots = TableHeaderSlots;

// @public
export type DataGridHeaderState = TableHeaderState;

// @public
export type DataGridProps = TableProps & Pick<DataGridContextValue, 'items' | 'columns'>;

// @public
export const DataGridRow: ForwardRefComponent<DataGridRowProps>;

// @public (undocumented)
export const dataGridRowClassNames: SlotClassNames<DataGridRowSlots>;

// @public
export type DataGridRowProps = Omit<TableRowProps, 'children'> & {
    children: CellRenderFunction;
};

// @public (undocumented)
export type DataGridRowSlots = TableRowSlots;

// @public
export type DataGridRowState = TableRowState;

// @public
export const DataGridSelectionCell: ForwardRefComponent<DataGridSelectionCellProps>;

// @public (undocumented)
export const dataGridSelectionCellClassNames: SlotClassNames<DataGridSelectionCellSlots>;

// @public
export type DataGridSelectionCellProps = TableSelectionCellProps;

// @public (undocumented)
export type DataGridSelectionCellSlots = TableSelectionCellSlots;

// @public
export type DataGridSelectionCellState = TableSelectionCellState;

// @public (undocumented)
export type DataGridSlots = TableSlots;

// @public
export type DataGridState = TableState & {
    tableState: HeadlessTableState<unknown>;
};

// @public (undocumented)
export interface HeadlessTableState<TItem> extends Pick<UseTableOptions<TItem>, 'items' | 'getRowId'> {
    columns: ColumnDefinition<TItem>[];
    getRows: <TRowState extends RowState<TItem> = RowState<TItem>>(rowEnhancer?: RowEnhancer<TItem, TRowState>) => TRowState[];
    selection: TableSelectionState;
    sort: TableSortState<TItem>;
}

// @public
export const renderDataGrid_unstable: (state: DataGridState, contextValues: DataGridContextValues) => JSX.Element;

// @public
export const renderDataGridBody_unstable: (state: DataGridBodyState) => JSX.Element;

// @public
export const renderDataGridCell_unstable: (state: DataGridCellState) => JSX.Element;

// @public
export const renderDataGridHeader_unstable: (state: DataGridHeaderState) => JSX.Element;

// @public
export const renderDataGridHeaderCell_unstable: (state: DataGridHeaderCellState) => JSX.Element;

// @public
export const renderDataGridRow_unstable: (state: DataGridRowState) => JSX.Element;

// @public
export const renderDataGridSelectionCell_unstable: (state: DataGridSelectionCellState) => JSX.Element;

// @public
export const renderTable_unstable: (state: TableState, contextValues: TableContextValues) => JSX.Element;

// @public
export const renderTableBody_unstable: (state: TableBodyState) => JSX.Element;

// @public
export const renderTableCell_unstable: (state: TableCellState) => JSX.Element;

// @public
export const renderTableCellActions_unstable: (state: TableCellActionsState) => JSX.Element;

// @public
export const renderTableCellLayout_unstable: (state: TableCellLayoutState, contextValues: TableCellLayoutContextValues) => JSX.Element;

// @public
export const renderTableHeader_unstable: (state: TableHeaderState) => JSX.Element;

// @public
export const renderTableHeaderCell_unstable: (state: TableHeaderCellState) => JSX.Element;

// @public
export const renderTableRow_unstable: (state: TableRowState) => JSX.Element;

// @public
export const renderTableSelectionCell_unstable: (state: TableSelectionCellState) => JSX.Element;

// @public (undocumented)
export type RowId = string | number;

// @public (undocumented)
export type RowRenderFunction<TItem = any> = (row: RowState<TItem>) => React_2.ReactNode;

// @public (undocumented)
export interface RowState<TItem> {
    item: TItem;
    rowId: RowId;
}

// @public (undocumented)
export type SortDirection = 'ascending' | 'descending';

// @public
export const Table: ForwardRefComponent<TableProps>;

// @public
export const TableBody: ForwardRefComponent<TableBodyProps>;

// @public (undocumented)
export const tableBodyClassName = "fui-TableBody";

// @public (undocumented)
export const tableBodyClassNames: SlotClassNames<TableBodySlots>;

// @public
export type TableBodyProps = ComponentProps<TableBodySlots>;

// @public (undocumented)
export type TableBodySlots = {
    root: Slot<'tbody', 'div'>;
};

// @public
export type TableBodyState = ComponentState<TableBodySlots> & Pick<TableContextValue, 'noNativeElements'>;

// @public
export const TableCell: ForwardRefComponent<TableCellProps>;

// @public
export const TableCellActions: ForwardRefComponent<TableCellActionsProps>;

// @public (undocumented)
export const tableCellActionsClassNames: SlotClassNames<TableCellActionsSlots>;

// @public
export type TableCellActionsProps = ComponentProps<TableCellActionsSlots> & {
    visible?: boolean;
};

// @public (undocumented)
export type TableCellActionsSlots = {
    root: Slot<'div'>;
};

// @public
export type TableCellActionsState = ComponentState<TableCellActionsSlots> & Pick<Required<TableCellActionsProps>, 'visible'>;

// @public (undocumented)
export const tableCellClassName = "fui-TableCell";

// @public (undocumented)
export const tableCellClassNames: SlotClassNames<TableCellSlots>;

// @public
export const TableCellLayout: ForwardRefComponent<TableCellLayoutProps>;

// @public (undocumented)
export const tableCellLayoutClassNames: SlotClassNames<TableCellLayoutSlots>;

// @public
export type TableCellLayoutProps = ComponentProps<Partial<TableCellLayoutSlots>> & {
    appearance?: 'primary';
};

// @public (undocumented)
export type TableCellLayoutSlots = {
    root: Slot<'div'>;
    media: Slot<'span'>;
    main: Slot<'span'>;
    description: Slot<'span'>;
    wrapper: Slot<'div'>;
};

// @public
export type TableCellLayoutState = ComponentState<TableCellLayoutSlots> & Pick<TableCellLayoutProps, 'appearance'> & {
    avatarSize: AvatarSizes | undefined;
};

// @public
export type TableCellProps = ComponentProps<TableCellSlots> & {};

// @public (undocumented)
export type TableCellSlots = {
    root: Slot<'td', 'div'>;
};

// @public
export type TableCellState = ComponentState<TableCellSlots> & Pick<TableContextValue, 'noNativeElements'>;

// @public (undocumented)
export const tableClassName = "fui-Table";

// @public (undocumented)
export const tableClassNames: SlotClassNames<TableSlots>;

// @public (undocumented)
export const TableContextProvider: React_2.Provider<TableContextValue | undefined>;

// @public (undocumented)
export type TableContextValue = {
    size: 'small' | 'smaller' | 'medium';
    noNativeElements: boolean;
    sortable: boolean;
};

// @public (undocumented)
export type TableContextValues = {
    table: TableContextValue;
};

// @public
export const TableHeader: ForwardRefComponent<TableHeaderProps>;

// @public
export const TableHeaderCell: ForwardRefComponent<TableHeaderCellProps>;

// @public (undocumented)
export const tableHeaderCellClassName = "fui-TableHeaderCell";

// @public (undocumented)
export const tableHeaderCellClassNames: SlotClassNames<TableHeaderCellSlots>;

// @public
export type TableHeaderCellProps = ComponentProps<Partial<TableHeaderCellSlots>> & {
    sortDirection?: SortDirection;
};

// @public (undocumented)
export type TableHeaderCellSlots = {
    root: Slot<'th', 'div'>;
    sortIcon: Slot<'span'>;
    button: NonNullable<Slot<ARIAButtonSlotProps>>;
};

// @public
export type TableHeaderCellState = ComponentState<TableHeaderCellSlots> & Pick<TableContextValue, 'noNativeElements' | 'sortable'>;

// @public (undocumented)
export const tableHeaderClassName = "fui-TableHeader";

// @public (undocumented)
export const tableHeaderClassNames: SlotClassNames<TableHeaderSlots>;

// @public
export type TableHeaderProps = ComponentProps<TableHeaderSlots> & {};

// @public (undocumented)
export type TableHeaderSlots = {
    root: Slot<'thead', 'div'>;
};

// @public
export type TableHeaderState = ComponentState<TableHeaderSlots> & Pick<TableContextValue, 'noNativeElements'>;

// @public
export type TableProps = ComponentProps<TableSlots> & Partial<TableContextValue>;

// @public
export const TableRow: ForwardRefComponent<TableRowProps>;

// @public (undocumented)
export const tableRowClassName = "fui-TableRow";

// @public (undocumented)
export const tableRowClassNames: SlotClassNames<TableRowSlots>;

// @public
export type TableRowProps = ComponentProps<TableRowSlots> & {
    appearance?: 'brand' | 'neutral' | 'none';
};

// @public (undocumented)
export type TableRowSlots = {
    root: Slot<'tr', 'div'>;
};

// @public
export type TableRowState = ComponentState<TableRowSlots> & Pick<TableContextValue, 'noNativeElements' | 'size'> & Pick<Required<TableRowProps>, 'appearance'>;

// @public
export const TableSelectionCell: ForwardRefComponent<TableSelectionCellProps>;

// @public (undocumented)
export const tableSelectionCellClassNames: SlotClassNames<TableSelectionCellSlots>;

// @public
export type TableSelectionCellProps = ComponentProps<Partial<Omit<TableSelectionCellSlots, 'media'>>> & {
    type?: 'checkbox' | 'radio';
    checked?: CheckboxProps['checked'];
    subtle?: boolean;
    hidden?: boolean;
};

// @public (undocumented)
export type TableSelectionCellSlots = {
    checkboxIndicator: Slot<typeof Checkbox>;
    radioIndicator: Slot<typeof Radio>;
} & Pick<TableCellSlots, 'root'>;

// @public
export type TableSelectionCellState = ComponentState<TableSelectionCellSlots> & Pick<Required<TableSelectionCellProps>, 'type' | 'checked' | 'subtle' | 'hidden'> & Pick<TableContextValue, 'noNativeElements'>;

// @public (undocumented)
export interface TableSelectionState {
    allRowsSelected: boolean;
    clearRows: () => void;
    deselectRow: (rowId: RowId) => void;
    isRowSelected: (rowId: RowId) => boolean;
    selectedRows: Set<RowId>;
    selectRow: (rowId: RowId) => void;
    someRowsSelected: boolean;
    toggleAllRows: () => void;
    toggleRow: (rowId: RowId) => void;
}

// @public (undocumented)
export type TableSlots = {
    root: Slot<'table', 'div'>;
};

// @public (undocumented)
export interface TableSortState<TItem> {
    getSortDirection: (columnId: ColumnId) => SortDirection | undefined;
    setColumnSort: (columnId: ColumnId, sortDirection: SortDirection) => void;
    sort: <TRowState extends RowState<TItem>>(rows: TRowState[]) => TRowState[];
    sortColumn: ColumnId | undefined;
    sortDirection: SortDirection;
    toggleColumnSort: (columnId: ColumnId) => void;
}

// @public
export type TableState = ComponentState<TableSlots> & Pick<Required<TableProps>, 'size' | 'noNativeElements'> & TableContextValue;

// @public (undocumented)
export type TableStatePlugin = <TItem>(tableState: HeadlessTableState<TItem>) => HeadlessTableState<TItem>;

// @public
export const useDataGrid_unstable: (props: DataGridProps, ref: React_2.Ref<HTMLElement>) => DataGridState;

// @public
export const useDataGridBody_unstable: (props: DataGridBodyProps, ref: React_2.Ref<HTMLElement>) => DataGridBodyState;

// @public
export const useDataGridBodyStyles_unstable: (state: DataGridBodyState) => DataGridBodyState;

// @public
export const useDataGridCell_unstable: (props: DataGridCellProps, ref: React_2.Ref<HTMLElement>) => DataGridCellState;

// @public
export const useDataGridCellStyles_unstable: (state: DataGridCellState) => DataGridCellState;

// @public
export const useDataGridHeader_unstable: (props: DataGridHeaderProps, ref: React_2.Ref<HTMLElement>) => DataGridHeaderState;

// @public
export const useDataGridHeaderCell_unstable: (props: DataGridHeaderCellProps, ref: React_2.Ref<HTMLElement>) => DataGridHeaderCellState;

// @public
export const useDataGridHeaderCellStyles_unstable: (state: DataGridHeaderCellState) => DataGridHeaderCellState;

// @public
export const useDataGridHeaderStyles_unstable: (state: DataGridHeaderState) => DataGridHeaderState;

// @public
export const useDataGridRow_unstable: (props: DataGridRowProps, ref: React_2.Ref<HTMLElement>) => DataGridRowState;

// @public
export const useDataGridRowStyles_unstable: (state: DataGridRowState) => DataGridRowState;

// @public
export const useDataGridSelectionCell_unstable: (props: DataGridSelectionCellProps, ref: React_2.Ref<HTMLElement>) => DataGridSelectionCellState;

// @public
export const useDataGridSelectionCellStyles_unstable: (state: DataGridSelectionCellState) => DataGridSelectionCellState;

// @public
export const useDataGridStyles_unstable: (state: DataGridState) => DataGridState;

// @public (undocumented)
export function useSelection<TItem>(options: UseSelectionOptions): (tableState: HeadlessTableState<TItem>) => HeadlessTableState<TItem>;

// @public (undocumented)
export function useSort<TItem>(options: UseSortOptions): (tableState: HeadlessTableState<TItem>) => HeadlessTableState<TItem>;

// @public (undocumented)
export function useTable<TItem>(options: UseTableOptions<TItem>, plugins?: TableStatePlugin[]): HeadlessTableState<TItem>;

// @public
export const useTable_unstable: (props: TableProps, ref: React_2.Ref<HTMLElement>) => TableState;

// @public
export const useTableBody_unstable: (props: TableBodyProps, ref: React_2.Ref<HTMLElement>) => TableBodyState;

// @public
export const useTableBodyStyles_unstable: (state: TableBodyState) => TableBodyState;

// @public
export const useTableCell_unstable: (props: TableCellProps, ref: React_2.Ref<HTMLElement>) => TableCellState;

// @public
export const useTableCellActions_unstable: (props: TableCellActionsProps, ref: React_2.Ref<HTMLElement>) => TableCellActionsState;

// @public
export const useTableCellActionsStyles_unstable: (state: TableCellActionsState) => TableCellActionsState;

// @public
export const useTableCellLayout_unstable: (props: TableCellLayoutProps, ref: React_2.Ref<HTMLElement>) => TableCellLayoutState;

// @public
export const useTableCellLayoutStyles_unstable: (state: TableCellLayoutState) => TableCellLayoutState;

// @public
export const useTableCellStyles_unstable: (state: TableCellState) => TableCellState;

// @public (undocumented)
export const useTableContext: () => TableContextValue;

// @public
export const useTableHeader_unstable: (props: TableHeaderProps, ref: React_2.Ref<HTMLElement>) => TableHeaderState;

// @public
export const useTableHeaderCell_unstable: (props: TableHeaderCellProps, ref: React_2.Ref<HTMLElement>) => TableHeaderCellState;

// @public
export const useTableHeaderCellStyles_unstable: (state: TableHeaderCellState) => TableHeaderCellState;

// @public
export const useTableHeaderStyles_unstable: (state: TableHeaderState) => TableHeaderState;

// @public (undocumented)
export interface UseTableOptions<TItem> {
    // (undocumented)
    columns: ColumnDefinition<TItem>[];
    // (undocumented)
    getRowId?: (item: TItem) => RowId;
    // (undocumented)
    items: TItem[];
}

// @public
export const useTableRow_unstable: (props: TableRowProps, ref: React_2.Ref<HTMLElement>) => TableRowState;

// @public
export const useTableRowStyles_unstable: (state: TableRowState) => TableRowState;

// @public
export const useTableSelectionCell_unstable: (props: TableSelectionCellProps, ref: React_2.Ref<HTMLElement>) => TableSelectionCellState;

// @public
export const useTableSelectionCellStyles_unstable: (state: TableSelectionCellState) => TableSelectionCellState;

// @public
export const useTableStyles_unstable: (state: TableState) => TableState;

// (No @packageDocumentation comment for this package)

```
